# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AssetXO(BaseModel):
    """
    AssetXO
    """ # noqa: E501
    blob_created: Optional[datetime] = Field(default=None, alias="blobCreated")
    blob_store_name: Optional[StrictStr] = Field(default=None, alias="blobStoreName")
    checksum: Optional[Dict[str, StrictStr]] = None
    content_type: Optional[StrictStr] = Field(default=None, alias="contentType")
    download_url: Optional[StrictStr] = Field(default=None, alias="downloadUrl")
    file_size: Optional[StrictInt] = Field(default=None, alias="fileSize")
    format: Optional[StrictStr] = None
    id: Optional[StrictStr] = None
    last_downloaded: Optional[datetime] = Field(default=None, alias="lastDownloaded")
    last_modified: Optional[datetime] = Field(default=None, alias="lastModified")
    path: Optional[StrictStr] = None
    repository: Optional[StrictStr] = None
    uploader: Optional[StrictStr] = None
    uploader_ip: Optional[StrictStr] = Field(default=None, alias="uploaderIp")
    __properties: ClassVar[List[str]] = ["blobCreated", "blobStoreName", "checksum", "contentType", "downloadUrl", "fileSize", "format", "id", "lastDownloaded", "lastModified", "path", "repository", "uploader", "uploaderIp"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssetXO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssetXO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "blobCreated": obj.get("blobCreated"),
            "blobStoreName": obj.get("blobStoreName"),
            "checksum": obj.get("checksum"),
            "contentType": obj.get("contentType"),
            "downloadUrl": obj.get("downloadUrl"),
            "fileSize": obj.get("fileSize"),
            "format": obj.get("format"),
            "id": obj.get("id"),
            "lastDownloaded": obj.get("lastDownloaded"),
            "lastModified": obj.get("lastModified"),
            "path": obj.get("path"),
            "repository": obj.get("repository"),
            "uploader": obj.get("uploader"),
            "uploaderIp": obj.get("uploaderIp")
        })
        return _obj


