# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from nexus_api_client.models.blob_store_api_soft_quota import BlobStoreApiSoftQuota
from nexus_api_client.models.google_cloud_blob_store_api_bucket_configuration import GoogleCloudBlobStoreApiBucketConfiguration
from typing import Optional, Set
from typing_extensions import Self

class GoogleCloudBlobstoreApiModel(BaseModel):
    """
    GoogleCloudBlobstoreApiModel
    """ # noqa: E501
    bucket_configuration: GoogleCloudBlobStoreApiBucketConfiguration = Field(alias="bucketConfiguration")
    name: StrictStr = Field(description="The name of the GC Storage blob store.")
    soft_quota: Optional[BlobStoreApiSoftQuota] = Field(default=None, alias="softQuota")
    type: Optional[StrictStr] = Field(default=None, description="The blob store type.")
    __properties: ClassVar[List[str]] = ["bucketConfiguration", "name", "softQuota", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleCloudBlobstoreApiModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "type",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of bucket_configuration
        if self.bucket_configuration:
            _dict['bucketConfiguration'] = self.bucket_configuration.to_dict()
        # override the default output from pydantic by calling `to_dict()` of soft_quota
        if self.soft_quota:
            _dict['softQuota'] = self.soft_quota.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleCloudBlobstoreApiModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bucketConfiguration": GoogleCloudBlobStoreApiBucketConfiguration.from_dict(obj["bucketConfiguration"]) if obj.get("bucketConfiguration") is not None else None,
            "name": obj.get("name"),
            "softQuota": BlobStoreApiSoftQuota.from_dict(obj["softQuota"]) if obj.get("softQuota") is not None else None,
            "type": obj.get("type")
        })
        return _obj


