# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from nexus_api_client.models.http_client_connection_attributes import HttpClientConnectionAttributes
from nexus_api_client.models.http_client_connection_authentication_attributes_with_preemptive import HttpClientConnectionAuthenticationAttributesWithPreemptive
from typing import Optional, Set
from typing_extensions import Self

class HttpClientAttributesWithPreemptiveAuth(BaseModel):
    """
    HttpClientAttributesWithPreemptiveAuth
    """ # noqa: E501
    authentication: Optional[HttpClientConnectionAuthenticationAttributesWithPreemptive] = None
    auto_block: StrictBool = Field(description="Whether to auto-block outbound connections if remote peer is detected as unreachable/unresponsive", alias="autoBlock")
    blocked: StrictBool = Field(description="Whether to block outbound connections on the repository")
    connection: Optional[HttpClientConnectionAttributes] = None
    __properties: ClassVar[List[str]] = ["authentication", "autoBlock", "blocked", "connection"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of HttpClientAttributesWithPreemptiveAuth from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of authentication
        if self.authentication:
            _dict['authentication'] = self.authentication.to_dict()
        # override the default output from pydantic by calling `to_dict()` of connection
        if self.connection:
            _dict['connection'] = self.connection.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of HttpClientAttributesWithPreemptiveAuth from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "authentication": HttpClientConnectionAuthenticationAttributesWithPreemptive.from_dict(obj["authentication"]) if obj.get("authentication") is not None else None,
            "autoBlock": obj.get("autoBlock"),
            "blocked": obj.get("blocked"),
            "connection": HttpClientConnectionAttributes.from_dict(obj["connection"]) if obj.get("connection") is not None else None
        })
        return _obj


