# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class MavenAttributes(BaseModel):
    """
    MavenAttributes
    """ # noqa: E501
    content_disposition: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Content Disposition", alias="contentDisposition")
    layout_policy: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Validate that all paths are maven artifact or metadata paths", alias="layoutPolicy")
    version_policy: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="What type of artifacts does this repository store?", alias="versionPolicy")
    __properties: ClassVar[List[str]] = ["contentDisposition", "layoutPolicy", "versionPolicy"]

    @field_validator('content_disposition')
    def content_disposition_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"INLINE|ATTACHMENT", value):
            raise ValueError(r"must validate the regular expression /INLINE|ATTACHMENT/")
        return value

    @field_validator('content_disposition')
    def content_disposition_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['INLINE', 'ATTACHMENT']):
            raise ValueError("must be one of enum values ('INLINE', 'ATTACHMENT')")
        return value

    @field_validator('layout_policy')
    def layout_policy_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"STRICT|PERMISSIVE", value):
            raise ValueError(r"must validate the regular expression /STRICT|PERMISSIVE/")
        return value

    @field_validator('layout_policy')
    def layout_policy_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['STRICT', 'PERMISSIVE']):
            raise ValueError("must be one of enum values ('STRICT', 'PERMISSIVE')")
        return value

    @field_validator('version_policy')
    def version_policy_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"RELEASE|SNAPSHOT|MIXED", value):
            raise ValueError(r"must validate the regular expression /RELEASE|SNAPSHOT|MIXED/")
        return value

    @field_validator('version_policy')
    def version_policy_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['RELEASE', 'SNAPSHOT', 'MIXED']):
            raise ValueError("must be one of enum values ('RELEASE', 'SNAPSHOT', 'MIXED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MavenAttributes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MavenAttributes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contentDisposition": obj.get("contentDisposition"),
            "layoutPolicy": obj.get("layoutPolicy"),
            "versionPolicy": obj.get("versionPolicy")
        })
        return _obj


