# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from nexus_api_client.models.group_attributes import GroupAttributes
from nexus_api_client.models.raw_attributes import RawAttributes
from nexus_api_client.models.storage_attributes import StorageAttributes
from typing import Optional, Set
from typing_extensions import Self

class RawGroupApiRepository(BaseModel):
    """
    RawGroupApiRepository
    """ # noqa: E501
    format: StrictStr
    group: GroupAttributes
    name: Annotated[str, Field(strict=True)] = Field(description="A unique identifier for this repository")
    online: StrictBool = Field(description="Whether this repository accepts incoming requests")
    raw: RawAttributes
    storage: StorageAttributes
    type: StrictStr
    url: StrictStr
    __properties: ClassVar[List[str]] = ["format", "group", "name", "online", "raw", "storage", "type", "url"]

    @field_validator('name')
    def name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-zA-Z0-9\-]{1}[a-zA-Z0-9_\-\.]*$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9\-]{1}[a-zA-Z0-9_\-\.]*$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RawGroupApiRepository from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of group
        if self.group:
            _dict['group'] = self.group.to_dict()
        # override the default output from pydantic by calling `to_dict()` of raw
        if self.raw:
            _dict['raw'] = self.raw.to_dict()
        # override the default output from pydantic by calling `to_dict()` of storage
        if self.storage:
            _dict['storage'] = self.storage.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RawGroupApiRepository from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "format": obj.get("format") if obj.get("format") is not None else 'raw',
            "group": GroupAttributes.from_dict(obj["group"]) if obj.get("group") is not None else None,
            "name": obj.get("name"),
            "online": obj.get("online"),
            "raw": RawAttributes.from_dict(obj["raw"]) if obj.get("raw") is not None else None,
            "storage": StorageAttributes.from_dict(obj["storage"]) if obj.get("storage") is not None else None,
            "type": obj.get("type") if obj.get("type") is not None else 'group',
            "url": obj.get("url")
        })
        return _obj


