# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SamlConfigurationXO(BaseModel):
    """
    SamlConfigurationXO
    """ # noqa: E501
    email_attribute: Optional[StrictStr] = Field(default=None, description="SAML attribute name for email", alias="emailAttribute")
    entity_id: Optional[StrictStr] = Field(default=None, description="SAML Service Provider's unique identifying URI", alias="entityId")
    first_name_attribute: Optional[StrictStr] = Field(default=None, description="SAML attribute name for the first name", alias="firstNameAttribute")
    groups_attribute: Optional[StrictStr] = Field(default=None, description="SAML attribute name for groups which maps the Identity Provider groups to a Nexus Repository Manager role", alias="groupsAttribute")
    idp_metadata: StrictStr = Field(description="SAML Identity Provider Metadata XML", alias="idpMetadata")
    last_name_attribute: Optional[StrictStr] = Field(default=None, description="SAML attribute name for the last name", alias="lastNameAttribute")
    username_attribute: StrictStr = Field(description="SAML attribute name for the username", alias="usernameAttribute")
    validate_assertion_signature: Optional[StrictBool] = Field(default=None, description="Validate signatures on assertions from Identity Provider", alias="validateAssertionSignature")
    validate_response_signature: Optional[StrictBool] = Field(default=None, description="Validate signatures on responses from Identity Provider", alias="validateResponseSignature")
    __properties: ClassVar[List[str]] = ["emailAttribute", "entityId", "firstNameAttribute", "groupsAttribute", "idpMetadata", "lastNameAttribute", "usernameAttribute", "validateAssertionSignature", "validateResponseSignature"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SamlConfigurationXO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SamlConfigurationXO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "emailAttribute": obj.get("emailAttribute"),
            "entityId": obj.get("entityId"),
            "firstNameAttribute": obj.get("firstNameAttribute"),
            "groupsAttribute": obj.get("groupsAttribute"),
            "idpMetadata": obj.get("idpMetadata"),
            "lastNameAttribute": obj.get("lastNameAttribute"),
            "usernameAttribute": obj.get("usernameAttribute"),
            "validateAssertionSignature": obj.get("validateAssertionSignature"),
            "validateResponseSignature": obj.get("validateResponseSignature")
        })
        return _obj


