# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from nexus_api_client.models.upload_field_definition_xo import UploadFieldDefinitionXO
from typing import Optional, Set
from typing_extensions import Self

class UploadDefinitionXO(BaseModel):
    """
    UploadDefinitionXO
    """ # noqa: E501
    asset_fields: Optional[List[UploadFieldDefinitionXO]] = Field(default=None, alias="assetFields")
    component_fields: Optional[List[UploadFieldDefinitionXO]] = Field(default=None, alias="componentFields")
    format: Optional[StrictStr] = None
    multiple_upload: Optional[StrictBool] = Field(default=None, alias="multipleUpload")
    __properties: ClassVar[List[str]] = ["assetFields", "componentFields", "format", "multipleUpload"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UploadDefinitionXO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in asset_fields (list)
        _items = []
        if self.asset_fields:
            for _item_asset_fields in self.asset_fields:
                if _item_asset_fields:
                    _items.append(_item_asset_fields.to_dict())
            _dict['assetFields'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in component_fields (list)
        _items = []
        if self.component_fields:
            for _item_component_fields in self.component_fields:
                if _item_component_fields:
                    _items.append(_item_component_fields.to_dict())
            _dict['componentFields'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UploadDefinitionXO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assetFields": [UploadFieldDefinitionXO.from_dict(_item) for _item in obj["assetFields"]] if obj.get("assetFields") is not None else None,
            "componentFields": [UploadFieldDefinitionXO.from_dict(_item) for _item in obj["componentFields"]] if obj.get("componentFields") is not None else None,
            "format": obj.get("format"),
            "multipleUpload": obj.get("multipleUpload")
        })
        return _obj


